﻿namespace HttpClientStudy.Core
{
    /// <summary>
    /// Http 错误处理
    /// </summary>
    public class HttpError
    {
        // 定义一个 HttpClient 实例,共享
        public static HttpClient HttpClient = new HttpClient(new SocketsHttpHandler() { PooledConnectionLifetime = TimeSpan.FromMinutes(1) })
        {
            BaseAddress = new Uri(WebApiConfig.WebApiBaseUrl)
        };

        public async Task<HttpStatusCode> UrlNotFoundAsync()
        {
            var response = await HttpClient.GetAsync("http://www.notingxxxxxxxx.com/404.html");

            response.EnsureSuccessStatusCode();

            return response.StatusCode;
        }

        public async Task<HttpStatusCode> Http404Async()
        { 
            var response = await HttpClient.GetAsync("http://www.baidu.com/404.html");

            response.EnsureSuccessStatusCode();

            return response.StatusCode;
        }

    }
}
